// spacing style

@use 'fun';

// one value is all four sides
// two value is top and bottom | left and right
// three value is top | left and right | bottom
// four value is top | right | bottom | left
@mixin margin($value) {
  margin: $value;
}

@mixin margin-none() {
  @include margin(0);
}

@mixin margin-top($value) {
  @include fun.affix('margin', $value, 'top');
}

@mixin margin-bottom($value) {
  @include fun.affix('margin', $value, 'bottom');
}

@mixin margin-left($value) {
  @include fun.affix('margin', $value, 'left');
}

@mixin margin-right($value) {
  @include fun.affix('margin', $value, 'right');
}

@mixin margin-x($value) {
  @include fun.affix('margin', $value, 'left', 'right');
}

@mixin margin-y($value) {
  @include fun.affix('margin', $value, 'top', 'bottom');
}

// one value is both
// two value is start | end
@mixin margin-block($value) {
  margin-block: $value;
}

@mixin margin-block-start($value) {
  margin-block-start: $value;
}

@mixin margin-block-end($value) {
  margin-block-end: $value;
}

@mixin margin-block-none() {
  @include margin-block(0);
}

// one value is both
// two value is start | end
@mixin margin-inline($value) {
  margin-inline: $value;
}

@mixin margin-inline-start($value) {
  margin-inline-start: $value;
}

@mixin margin-inline-end($value) {
  margin-inline-end: $value;
}

@mixin margin-inline-none() {
  @include margin-inline(0);
}

// one value is all four sides
// two value is top and bottom | left and right
// three value is top | left and right | bottom
// four value is top | right | bottom | left
@mixin padding($value) {
  padding: $value;
}

@mixin padding-none() {
  @include padding(0);
}

@mixin padding-top($value) {
  @include fun.affix('padding', $value, 'top');
}

@mixin padding-bottom($value) {
  @include fun.affix('padding', $value, 'bottom');
}

@mixin padding-left($value) {
  @include fun.affix('padding', $value, 'left');
}

@mixin padding-right($value) {
  @include fun.affix('padding', $value, 'right');
}

@mixin padding-x($value) {
  @include fun.affix('padding', $value, 'left', 'right');
}

@mixin padding-y($value) {
  @include fun.affix('padding', $value, 'top', 'bottom');
}

// one value is both
// two value is start | end
@mixin padding-block($value) {
  padding-block: $value;
}

@mixin padding-block-start($value) {
  padding-block-start: $value;
}

@mixin padding-block-end($value) {
  padding-block-end: $value;
}

@mixin padding-block-none() {
  @include padding-block(0);
}

// one value is both
// two value is start | end
@mixin padding-inline($value) {
  padding-inline: $value;
}

@mixin padding-inline-start($value) {
  padding-inline-start: $value;
}

@mixin padding-inline-end($value) {
  padding-inline-end: $value;
}

@mixin padding-inline-none() {
  @include padding-inline(0);
}
